
/*

LoadMoz.exe - which preloads the mozilla modules.
Portions derived from TrayIcon.exe by Antti Markus (antti@pld.ttu.ee).

*/

#ifndef __GNUC__
//useful defines
#define STRICT
#define WIN32_LEAN_AND_MEAN
#endif

//standard includes
#include <windows.h>

//this is not defined in mingw32 versions prior to 2.95
#ifndef TPM_BOTTOMALIGN
#define TPM_BOTTOMALIGN     0x0020L
#endif

//additional includes
#include "trayicon.h"
#include "resource.h"
#include <atlbase.h>

//trayicon notification message
#define WM_TRAY   WM_USER+0x100+5


LRESULT CALLBACK WindowFunc(HWND, UINT, WPARAM, LPARAM);

const char* pClassName="TTWin32TrayApp123"; //window class name
HINSTANCE hMainInst=0;    //application main instance handle

HICON hIcon1=0;
HICON gCheckIcons[2];

unsigned uWhich=0;        //indicates which icon is displayed
HMENU hPopup=0;           //menu handle
CTrayIcon* pTrayIcon=0;   //pointer to trayicon class


//Constants for my DLL loader to use...
static char gMozPath[2048]= {0};
static char gMozModuleList[2048] = {0};
static const char* gModuleCP=gMozModuleList;

static int gMozPathLen=0;
static const char *theMozPath=0;
static int  gDLLIndex=0;
static int  gTrayIconIndex = 0;

void GetDebugModuleList(char *aBuffer) {
  
  static const char* theModuleList = 

    "nspr4;plds4;plc4;mozreg;xpcom;img3250;zlib;" \

    "gkgfxwin;gkwidget;" \

    "components\\gkparser;" \
    "jpeg3250;" \
    "js3250;" \
    "jsj3250;" \
    "jsdom;" \
    "components\\jsloader;" \

    "components\\activation;" \
    "components\\appcomps;" \
    "components\\addrbook;" \
    "components\\appshell;" \
    "components\\caps;" \
    "components\\chardet;" \
    "components\\chrome;" \
    "components\\cookie;" \
    "components\\docshell;" \
    "components\\editor;" \
    "components\\gkplugin;" \
    "components\\gkview;" \
    "gkwidget;" \
    "components\\jar50;" \
    "components\\lwbrk;" \
    "mozreg;" \
    "components\\necko;" \
    "components\\necko2;" \
    "components\\nsgif;" \
    "components\\nslocale;" \
    "components\\nsprefm;" \
    "components\\profile;" \
    "components\\psmglue;" \
    "components\\rdf;" \
    "components\\shistory;" \
    "components\\strres;" \
    "components\\txmgr;" \
    "components\\txtsvc;" \
    "components\\ucharuti;" \
    "components\\uconv;" \
    "components\\ucvlatin;" \
    "components\\ucvcn;" \
    "components\\ucvja;" \
    "components\\urildr;" \
    "components\\ucvtw2;" \
    "components\\wallet;" \
    "components\\xpc3250;" \
    "components\\xpinstal;" \
    "components\\xppref32;" \
    "components\\mozbrwsr;" \
    "components\\mozfind;" \
    "components\\webbrwsr;" \
    "components\\nsjpg;" \
    "components\\oji;" \

    "msgbsutl;" \
    "components\\absyncsv;" \
    "components\\mork;" \
    "components\\msglocal;" \
    "components\\msgbase;" \
    "components\\msgnews;" \
    "components\\msgimap;" \
    "components\\impeudra;" \
    "components\\import;" \
    "components\\imptext;" \

    "components\\nsmng;" \
    "components\\nspng;" \

    "xprt;" \
    "xptl;" \
    "xpcs";

  strcpy(aBuffer,theModuleList);

}

void Get60ModuleList(char *aBuffer) {
  
  static const char* theModuleList = 

    "nspr4;plds4;plc4;mozreg;xpcom;img3250;zlib;" \

    "gkgfxwin;gkwidget;" \

    "components\\gkparser;" \
    "jpeg3250;" \
    "js3250;" \
    "jsj3250;" \
    "jsdom;" \
    "components\\jsloader;" \

    "components\\activation;" \
    "components\\appcomps;" \
    "components\\addrbook;" \
    "components\\appshell;" \
    "components\\caps;" \
    "components\\chardet;" \
    "components\\chrome;" \
    "components\\cookie;" \
    "components\\docshell;" \
    "components\\editor;" \
    "components\\gkhtml;" \
    "components\\gkplugin;" \
    "components\\gkview;" \
    "gkwidget;" \
    "components\\jar50;" \
    "components\\lwbrk;" \
    "mozreg;" \
    "components\\necko;" \
    "components\\nsgif;" \
    "components\\nslocale;" \
    "components\\nsprefm;" \
    "components\\profile;" \
    "components\\psmglue;" \
    "components\\rdf;" \
    "components\\shistory;" \
    "components\\strres;" \
    "components\\txmgr;" \
    "components\\txtsvc;" \
    "components\\ucharuti;" \
    "components\\uconv;" \
    "components\\ucvlatin;" \
    "components\\ucvcn;" \
    "components\\ucvja;" \
    "components\\urildr;" \
    "components\\wallet;" \
    "components\\xpc3250;" \
    "components\\xpinstal;" \
    "components\\xppref32;" \
    "components\\mozbrwsr;" \
    "components\\nsjpg;" \
    "components\\oji;" \

    "msgbsutl;" \
    "components\\mork;" \
    "components\\msglocal;" \

    "xprt;" \
    "xptl;" \
    "xpcs";

  strcpy(aBuffer,theModuleList);

}

void Get65ModuleList(char *aBuffer) {
  static const char* theModuleList = 

  "nspr4;plds4;plc4;mozreg;xpcom;img3250;zlib;" \

  "gkgfxwin;gkwidget;" \

  "components\\gkparser;" \
  "jpeg3250;" \
  "js3250;" \
  "jsj3250;" \
  "jsdom;" \
  "components\\jsloader;" \

  "components\\activation;" \
  "components\\addrbook;" \
  "components\\appcomps;" \
  "components\\appshell;" \
  "components\\embedcomponents;"
  "components\\caps;" \
  "components\\chardet;" \
  "components\\chrome;" \
  "components\\cookie;" \
  "components\\docshell;" \
  "components\\editor;" \
  "components\\gkplugin;" \
  "components\\gkview;" \
  "gkwidget;" \
  "components\\jar50;" \
  "components\\lwbrk;" \
  "components\\necko;" \
  "components\\nsgif;" \
  "components\\nslocale;" \
  "components\\nsprefm;" \
  "components\\profile;" \
  "components\\psmglue;" \
  "components\\rdf;" \
  "components\\shistory;" \
  "components\\strres;" \
  "components\\txmgr;" \
  "components\\txtsvc;" \
  "components\\ucharuti;" \
  "components\\uconv;" \
  "components\\ucvlatin;" \
  "components\\ucvcn;" \
  "components\\ucvja;" \
  "components\\urildr;" \
  "components\\wallet;" \
  "components\\xpc3250;" \
  "components\\xpinstal;" \
  "components\\xppref32;" \
  "components\\xmlextras;" \

  "components\\gklayout;" \
  "components\\gkcontent;" \
  "components\\mozbrwsr;" \
  "components\\nsjpg;" \
  "components\\oji;" \

  "msgbsutl;" \
  "components\\mork;" \
  "components\\msglocal;" \

  "xprt;" \
  "xptl;" \
  "xpcs";
  
  strcpy(aBuffer,theModuleList);
}


//Get the path to the netscape6 browser via the registry...
void GetMozillaRegistryInfo(bool useDebugModuleList, bool getPathFromRegistry) {

  GetDebugModuleList(gMozModuleList);

  CRegKey theRegKey;

  const char* theKey  = "Software\\Netscape\\Netscape 6\\6.5 (en)\\Main";
  const char* theSubKey = "Install Directory";

  if(!useDebugModuleList) {
    Get65ModuleList(gMozModuleList);
  }

  LONG theOpenResult=theRegKey.Open(HKEY_LOCAL_MACHINE,theKey,KEY_QUERY_VALUE);

  if(ERROR_SUCCESS!=theOpenResult) {

    if(!useDebugModuleList) {
      Get60ModuleList(gMozModuleList);
    }

    if(ERROR_SUCCESS!=theOpenResult) {
      Get60ModuleList(gMozModuleList);
      theKey  = "Software\\Netscape\\Netscape 6\\6.0 (en)\\Main";
      theOpenResult=theRegKey.Open(HKEY_LOCAL_MACHINE,theKey,KEY_QUERY_VALUE);

      if(ERROR_SUCCESS!=theOpenResult) {
        theSubKey="Path";
        theKey  = "Software\\Microsoft\\Windows\\CurrentVersion\\App Paths\\netscp6.exe";
        theOpenResult=theRegKey.Open(HKEY_LOCAL_MACHINE,theKey,KEY_QUERY_VALUE);
      }

    }
  }

  if(ERROR_SUCCESS==theOpenResult) {

    DWORD theSize=1024;
    if(getPathFromRegistry) {  
      theRegKey.QueryValue(gMozPath,theSubKey,&theSize);
      gMozPathLen=strlen(gMozPath);
    }

    theSize=1024;
    char theCachedModuleList[1024] = {0};

    if(!useDebugModuleList) {
      theRegKey.QueryValue(theCachedModuleList,"Modules",&theSize);
    }

    if(theCachedModuleList[0]) {
      strcpy(gMozModuleList,theCachedModuleList);
    }

    gModuleCP = gMozModuleList;

    theRegKey.Create(HKEY_LOCAL_MACHINE,theKey);
    theRegKey.SetValue( HKEY_LOCAL_MACHINE, theKey, gMozModuleList, "Modules");
  }

}


//This is a hard-coded list of DLL's we need (in the order we need them).
//Later on we should get this list from the registry.
void GetNextModuleName(char* aName) {
  //scan ahead to find the next ';' or the end of the string...
  bool done=false;
  char theChar=0;

  aName[0]=0;

  const char *theCP=gModuleCP;

  while(*theCP) {
    theChar=*theCP;
    if(';'==theChar)
      break;
    else theCP++;
  }

  if(theCP!=gModuleCP) {
    size_t theSize=theCP-gModuleCP;
    strncpy(aName,gModuleCP,theSize);
    aName[theSize]=0;
    gModuleCP=theCP;
    while(';'==*gModuleCP)
      gModuleCP++;
  }

}

//...
typedef float (*VersionFunc)(void);

static HINSTANCE    gInstances[512];
static VersionFunc  gVersionFunc[512];
static int          gDLLCount=0;

HINSTANCE LoadModule(const char* aName) {

  //we operate on gMozPath directly to avoid an unnecessary string copy.
  //when we're done with this method, we reset gMozpath to it's original value for reuse.
  strcat(gMozPath,aName);
  strcat(gMozPath,".dll");
  
  HINSTANCE theInstance=gInstances[gDLLCount++]=LoadLibrary(gMozPath);
  gVersionFunc[gDLLCount-1]=(theInstance) ? (VersionFunc)GetProcAddress(theInstance, "GetVersionNumber") : 0;

  gMozPath[gMozPathLen]=0;
  return theInstance;
}


//This function get's called repeatedly to call GetProcAddr()
//which tries to keep the DLL's from being paged.

VOID CALLBACK KeepAliveTimerProc(
  HWND hwnd,     // handle of window for timer messages
  UINT uMsg,     // WM_TIMER message
  UINT idEvent,  // timer identifier
  DWORD dwTime   // current system time
  ) {

  static bool theTimerIsRunning=false;
  static int  theCurrentIndex=0;

  if(!theTimerIsRunning) { //ignore other timer calls till we're done.
    theTimerIsRunning=true;

    const int stepSize=5; //how many DLL's to "call" each time...
    for(int theIndex=0;theIndex<stepSize;theIndex++) {
      if(theCurrentIndex+theIndex<gDLLCount) {
        if(gVersionFunc[theCurrentIndex+theIndex]) {
          float v=gVersionFunc[theCurrentIndex+theIndex]();
        }        
      }
    }
    theCurrentIndex+=stepSize;

    if(theCurrentIndex>=gDLLCount)
      theCurrentIndex=0;//reset
    theTimerIsRunning=false;
  }
}


//this function get's called repeatedly until we've loaded all the DLL's. 
static HWND gMyWnd;

VOID CALLBACK LoadModuleTimerProc(
  HWND hwnd,     // handle of window for timer messages
  UINT uMsg,     // WM_TIMER message
  UINT idEvent,  // timer identifier
  DWORD dwTime   // current system time
  ) {

  static bool theTimerIsRunning=false;

  if(!theTimerIsRunning) {
    theTimerIsRunning=true;

    pTrayIcon->Modify(gCheckIcons[gTrayIconIndex]);
    gTrayIconIndex = (gTrayIconIndex==1) ? 0 : gTrayIconIndex+1;

    char theDLLName[512];
    GetNextModuleName(theDLLName);

    if(theDLLName[0]) {
      HINSTANCE theInstance=LoadModule(theDLLName);
    }
    else {
      KillTimer(gMyWnd,2);     
      pTrayIcon->Modify(gCheckIcons[1]);
      
      //now make a new one that calls GetProcAddr()...
      UINT result=SetTimer(gMyWnd,2,50,KeepAliveTimerProc);
      
    }

    theTimerIsRunning=false;
  }
}
 
/****************************************
  we support the following args:
    -d(+/-) : use debug module list
    -p : use the given path 
 ****************************************/
void ParseArgs(LPSTR &CmdLineArgs,bool &useDebugModuleList, bool &getPathFromRegistry) {

  const char* cp=CmdLineArgs;

  while(*cp) {
    char theChar=*cp;
    if(('-'==theChar) || ('/'==theChar)){
      //we found a valid command, go get it...
      ++cp;
      char theCmd=*cp;

      switch(theCmd) {
        case 'd':
        case 'D':
          ++cp;
          useDebugModuleList=('+'==*cp);
          break;
        case 'p':
        case 'P':
            //skip whitespace...
          cp++; //skip over the command...
          getPathFromRegistry=false;
          while(*cp) {
            if(' '!=*cp)
              break;
            cp++;
          }
            //now eat the path
          gMozPathLen=0;
          while(*cp) {
            if(' '!=*cp) {
              gMozPath[gMozPathLen++]=*cp;
            }
            cp++;
          }
          gMozPath[gMozPathLen]=0;
          continue;
          break;
        default:
          break;
      }
    }
    cp++; 
  }

}


int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPSTR lpszArgs,
                   int nWinMode)
{
  WNDCLASS WinClass;

  //register window class
  WinClass.hInstance=hInstance;
  hMainInst=hInstance;
  WinClass.lpszClassName=pClassName;  //specify class name
  WinClass.lpfnWndProc=WindowFunc;    //specify callback function
  WinClass.style=0;
  WinClass.hIcon=LoadIcon(NULL, IDI_APPLICATION); //specify icon
  WinClass.hCursor=LoadCursor(NULL, IDC_ARROW);   //specify cursor
  WinClass.lpszMenuName=0;
  WinClass.cbClsExtra=0;
  WinClass.cbWndExtra=0;
  WinClass.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH); //specify window background

  if(!RegisterClass(&WinClass))
    return 0;

  //create window
  HWND hwnd=CreateWindow(pClassName,
                         0,
                         WS_OVERLAPPEDWINDOW,
                         10,
                         10,
                         10,
                         10,
                         HWND_DESKTOP,
                         NULL,
                         hInstance,
                         NULL);

  //hide window
  ShowWindow(hwnd, SW_HIDE);

  bool useDebugModuleList=false;
  bool getPathFromRegistry=true;
  
  ParseArgs(lpszArgs,useDebugModuleList,getPathFromRegistry);
  GetMozillaRegistryInfo(useDebugModuleList,getPathFromRegistry); 

  gMyWnd=hwnd;

  //LoadSystemDLLs();

  UINT result=SetTimer(hwnd,2,50,LoadModuleTimerProc);
  
  //start message pump
  MSG WinMsg;
  while(GetMessage(&WinMsg, NULL, 0, 0))
  {
    TranslateMessage(&WinMsg);
    DispatchMessage(&WinMsg);
  }

  return WinMsg.wParam;
}

LRESULT CALLBACK WindowFunc(HWND hwnd, UINT Msg,
                            WPARAM wParam, LPARAM lParam)
{
  switch(Msg)
  {
    //application starts up
    case WM_CREATE:
    {
      //initialize icons
      hIcon1=LoadIcon(hMainInst, MAKEINTRESOURCE(IDI_CHECK));

      gCheckIcons[0]=LoadIcon(hMainInst, MAKEINTRESOURCE(IDI_CHECK));
      gCheckIcons[1]=LoadIcon(hMainInst, MAKEINTRESOURCE(IDI_CHECK1));

      //initialize popup menu
      hPopup=LoadMenu(hMainInst, MAKEINTRESOURCE(IDR_MENU));

      //initialize tray icon
      pTrayIcon=new CTrayIcon(hwnd, WM_TRAY, IDI_DOTS1, gCheckIcons[0], "Checked");
      //put icon to system tray
      pTrayIcon->Put();
      break;
    }

    //notification from trayicon received
    case WM_TRAY:
    {
      //if right mouse button pressed
      if(lParam == WM_RBUTTONDOWN)
      {
        POINT pt;
        GetCursorPos(&pt);  //get cursor position
        SetForegroundWindow(hwnd);  //set window to foreground
        //display popup menu
        BOOL bRes=TrackPopupMenu(GetSubMenu(hPopup, 0), TPM_BOTTOMALIGN | TPM_RIGHTALIGN,
                                 pt.x, pt.y, 0, hwnd, 0);
        //send dummy message to window
        SendMessage(hwnd, WM_NULL, 0, 0);
      }
      break;
    }

    //notification from menu received
    case WM_COMMAND:
    {
      switch(LOWORD(wParam))
      {
        case IDM_EXIT:
        {
          DestroyWindow(hwnd);
          break;
        }

        //change icon in system tray
        case IDM_CHANGE:
        {
          if(!uWhich)
          {
            uWhich=1;
            pTrayIcon->Modify(hIcon1);
            pTrayIcon->Modify("Crossed");
          }
          else
          {
            uWhich=0;
            pTrayIcon->Modify(hIcon1);
            pTrayIcon->Modify("Checked");
          }
          break;
        }
      }
      break;
    }

    //exit application
    case WM_DESTROY:
    {
      //release used resources

      delete pTrayIcon;
      DestroyIcon(hIcon1);

      DestroyIcon(gCheckIcons[0]);
      DestroyIcon(gCheckIcons[1]);

      DestroyMenu(hPopup);
      PostQuitMessage(0);
      break;
    }

    default:
      return DefWindowProc(hwnd, Msg, wParam, lParam);
  }
  return 0;
}

